Smart Proxy - Bug #1655

Failed to list puppet environments: Attempting to initialize global default settings more than once!
Description

Happens with smart-proxy git when trying to import classes and environments twice from foreman without restarting smart-proxy:

E, [2012-05-28T09:57:14.479552 #3577] ERROR -- : Failed to list puppet environments: Attempting to initialize global default
settings more than once! /usr/lib/ruby/1.8/puppet/settings.rb:136:in “initialize_global_settings'
/usr/lib/ruby/1.8/puppet.rb:140:in "do_initialize_settings_for_run_mode'

/ust/lib/ruby/1.8/puppet.rb:128:in “initialize_settings'
/ust/lib/ruby/1.8/puppet.rb:118:in “parse_config'
/home/orphis/smart-proxy/bin/../lib/proxy/puppet/environment.rb:24:in “puppet_environments'
/home/orphis/smart-proxy/bin/../lib/proxy/puppet/environment.rb:11:in “all’
/homef/orphis/smart-proxy/bin/../lib/puppet_api.rb:15:in "GET /puppet/environments'

/usr/lib/ruby/1.8/sinatra/base.rb:863:in
/usr/lib/ruby/1.8/sinatra/base.rb:863:in

/ust/lib/ruby/1.8/sinatra/base.rb:521:in
/ust/lib/ruby/1.8/sinatra/base.rb:500:in
/ust/lib/ruby/1.8/sinatra/base.rb:497:in
/ust/lib/ruby/1.8/sinatra/base.rb:497:in
/usr/lib/ruby/1.8/sinatra/base.rb:476:in
/usr/lib/ruby/1.8/sinatra/base.rb:476:in
/usr/lib/ruby/1.8/sinatra/base.rb:601:in
/usr/lib/ruby/1.8/sinatra/base.rb:411:in
/ust/lib/ruby/1.8/sinatra/base.rb:566:in

/ust/lib/ruby/1.8/sinatra/base.rb:566:in
/ust/lib/ruby/1.8/sinatra/base.rb:566:in
/ust/lib/ruby/1.8/sinatra/base.rb:411:in
/usr/lib/ruby/1.8/sinatra/base.rb:399:in

“call
“route’
/usr/lib/ruby/1.8/sinatra/base.rb:521:in °
‘route_eval'
“route!'

“catch’

‘route!'

“each’

‘route!’
“dispatch!'
“call!'
‘instance_eval'
/usr/lib/ruby/1.8/sinatra/base.rb:566:in *
“catch’
“invoke'
“call
“call

instance_eval'

invoke'

/usr/lib/ruby/1.8/rack/showexceptions.rb:24:in “call’

/usr/lib/ruby/1.8/rack/commonlogger.rb:
/usr/lib/ruby/1.8/sinatra/base.rb:979:in

18:in “call'
call

/usr/lib/ruby/1.8/sinatra/base.rb:1005:in “synchronize'

/usr/lib/ruby/1.8/sinatra/base.rb:979:in
/usr/lib/ruby/1.8/rack/content_length.rb:

call
13:in “call'

/ust/lib/ruby/1.8/rack/handler/webrick.rb:48:in “service'
/ust/lib/ruby/1.8/webrick/httpserver.rb:104:in “service'
/usr/lib/ruby/1.8/webrick/httpserver.rb:65:in “run’
/usr/lib/ruby/1.8/webrick/server.rb:173:in “start_thread'
/ust/lib/ruby/1.8/webrick/server.rb:162:in “start'
/usr/lib/ruby/1.8/webrick/server.rb:162:in “start_thread'
/ust/lib/ruby/1.8/webrick/server.rb:95:in “start’
/ust/lib/ruby/1.8/webrick/server.rb:92:in “each'’
/usr/lib/ruby/1.8/webrick/server.rb:92:in “start’
/usr/lib/ruby/1.8/webrick/server.rb:23:in “start’
/usr/lib/ruby/1.8/webrick/server.rb:82:in “start’
/usr/lib/ruby/1.8/rack/handler/webrick.rb:14:in “run’

/home/orphis/smart-proxy/bin/../lib/sinatra-patch.rb:36:in “run!'
https://projects.theforeman.org/issues/3577

/home/orphis/smart-proxy/bin/smart-proxy:102

History

#1 - 05/28/2012 06:51 AM - Florent Castelli
Probably related to puppet 3

#2 - 10/17/2012 07:44 PM - Myles Steinhauser

This is still an issue for me as of foreman-proxy from git. Running Puppet 3.0 so it is definitely related.

#3 - 11/28/2012 02:47 PM - Drew Blessing

This issue seems to be resolved by http://theforeman.org/issues/1915. | applied the changes from the commit at
https://qgithub.com/theforeman/smart-proxy/pull/42 and no longer saw this error.

#4 - 11/28/2012 02:51 PM - Dominic Cleal

- Status changed from New to Resolved

Thanks for confirming Drew!
